zoukankan      html  css  js  c++  java
  • hdu 4336 Card Collector(期望 dp 状态压缩)

    Problem Description
    In your childhood, do you crazy for collecting the beautiful cards in the snacks? They said that, for example, if you collect all the 108 people in the famous novel Water Margin, you will win an amazing award. 
    
    As a smart boy, you notice that to win the award, you must buy much more snacks than it seems to be. To convince your friends not to waste money any more, you should find the expected number of snacks one should buy to collect a full suit of cards.
    Input
    The first line of each test case contains one integer N (1 <= N <= 20), indicating the number of different cards you need the collect. The second line contains N numbers p1, p2, ..., pN, (p1 + p2 + ... + pN <= 1), indicating the possibility of each card to appear in a bag of snacks. 
    
    Note there is at most one card in a bag of snacks. And it is possible that there is nothing in the bag.
     
    Output
    Output one number for each test case, indicating the expected number of bags to buy to collect all the N different cards.
    
    You will get accepted if the difference between your answer and the standard answer is no more that 10^-4.
     
    Sample Input
    1 
    0.1 
    2 
    0.1 0.4
     
    Sample Output
    10.000 
    10.500
     
    Source

    题目大意


    买东西集齐全套卡片赢大奖。每个包装袋里面最多一张卡片,最少可以没有。且给了每种卡片出现的概率 p[i],以及所有的卡片种类的数量 n(1<=n<=20),问集齐卡片需要买东西的数量的期望值。需要注意的是 包装袋中可以没有卡片,也就是说:segma{ p[i] }<=1.0,i=0,2,...,n-1

     

    做法分析


    由于卡片最多只有 20 种,使用状态压缩,用 0 表示这种卡片没有收集到, 1 表示这种卡片收集到了

    令:f[s] 表示已经集齐的卡片种类的状态的情况下,收集完所有卡片需要买东西次数的期望

    买一次东西,包装袋中可能:

            1. 没有卡片

            2. 卡片是已经收集到的

            3. 卡片是没有收集到的

    于是有:

            f[s] = 1 + ((1-segma{ p[i] })f[s]) + (segma{ p[j]*f[s] }) + (segma{ p[k]*f[s|(1<<k)] })

            其中:    i=0,2,...,n-1

                          j=第 j 种卡片已经收集到了,即 s 从右往左数第 j 位是 1:s&(1<<j)!=0

                          k=第 k 种卡片没有收集到,即 s 从右往左数第 k 位是 0:s&(1<<k)==0

    移项可得:

            segma{ p[i] }f[s] = 1 + segma{ p[i]*f[s|(1<<i) },i=第i 种卡片没有收集到

    目标状态是:f[0]

     1 #include<iostream>
     2 #include<cstdio>
     3 #include<cstring>
     4 using namespace std;
     5 #define N 26
     6 #define M 1<<21
     7 double p[N];
     8 double dp[M];
     9 int main()
    10 {
    11     int n;
    12     while(scanf("%d",&n)!=EOF){
    13          //double sum=0;
    14         for(int i=0;i<n;i++){
    15             scanf("%lf",&p[i]);
    16             //sum+=p[i];
    17         }
    18         
    19         int all=(1<<n)-1;
    20         dp[all]=0;
    21         for(int i=all-1;i>=0;i--){
    22             dp[i]=1;
    23             double tmp=0;
    24             for(int j=0;j<n;j++){
    25                 if(i&(1<<j)) continue;
    26                 dp[i]=dp[i]+dp[i|(1<<j)]*p[j];
    27                 tmp+=p[j];
    28             }
    29             dp[i]/=tmp;
    30         }
    31         
    32         printf("%lf
    ",dp[0]);
    33         
    34     }
    35     return 0;
    36 } 
    View Code
  • 相关阅读:
    【BZOJ2424】[HAOI2010]订货 最小费用流
    【BZOJ1935/4822】[Shoi2007]Tree 园丁的烦恼/[Cqoi2017]老C的任务 树状数组
    【BZOJ2500】幸福的道路 树形DP+RMQ+双指针法
    【BZOJ4726】[POI2017]Sabota? 树形DP
    【BZOJ4883】[Lydsy2017年5月月赛]棋盘上的守卫 KM算法
    【BZOJ4881】5月月赛D 线段游戏 树状数组+set
    【BZOJ4518】[Sdoi2016]征途 斜率优化
    【BZOJ4818】[Sdoi2017]序列计数 DP+矩阵乘法
    【BZOJ2553】[BeiJing2011]禁忌 AC自动机+期望DP+矩阵乘法
    【BZOJ3211】花神游历各国 并查集+树状数组
  • 原文地址:https://www.cnblogs.com/UniqueColor/p/4792306.html
Copyright © 2011-2022 走看看